<template>
    <div id="app">
      <p class="text">Start: {{clock.startTime}}</p>
    </div>

    <div class="wrapper">
        <div class="time">
            <span class="hour text">{{clock.hr < 10 ? "0" + clock.hr: clock.hr}}</span>
            <span class="colone text">:</span>
            <span class="minute text">{{clock.min < 10 ? "0" + clock.min : clock.min}}</span>
            <span class="colone text">:</span>
            <span class="seconde text">{{clock.sec < 10 ? "0" + clock.sec : clock.sec}}</span>
        </div>
        <div class="button">
            <button v-if="!clock.started" class="btn btn-success" @click="startAndStopClock">Start</button>
            <button v-if="clock.started" class=" btn btn-danger" @click="startAndStopClock">End</button>
        </div>
    </div>
</template>

<script>
export default {
    emits: ["updateCharts"],
    mounted() {
        if (localStorage.getItem('id')) {
            this.user.id = localStorage.getItem('id')
            this.user.token = localStorage.getItem('token')
        }
        this.fetchClocks();
    },
    data() {
        return {
            user: {
                id: "",
                token: "",
                role: ""
            },
            clock: {
                hr: 0,
                min: 0,
                sec: 0,
                started: false,
                startTime: ""
            },
            time: null,
            startTimer: null,
            input: {
                start: "",
                status: ""
            },
        }
    },
    methods: {
        start() {
            if (this.clock.started == true) {
                return; // pas demarrer plus d'une fois car deja demarree
            }
            this.updateStartTime()
            this.startTimer = setInterval(()=>{
                this.clock.sec++
                if (this.clock.sec === 60){
                    this.clock.min++
                    this.clock.sec = 0
                }
                if (this.clock.min === 60){
                    this.clock.hr++
                    this.clock.min = 0
                }
            },1000)
            this.clock.started = true
        },
        end() {
            if (this.clock.startTime != "") {
                this.updateWorkingTime()
            }
            this.clock.started = false
            this.time = null
            this.clock.hr = 0;
            this.clock.min = 0;
            this.clock.sec = 0;
            this.clock.startTime = ""
            clearInterval(this.startTimer)
        },
        async updateWorkingTime() {
            let timeStart = new Date(this.clock.startTime)
            let timeEnd = new Date()
            timeStart.setMinutes(timeStart.getMinutes() - new Date().getTimezoneOffset())
            timeEnd.setMinutes(timeEnd.getMinutes() - new Date().getTimezoneOffset())
            const url = 'http://localhost:4000/api/workingtimes/' + this.user.id
            await fetch(url, {
                method: 'POST',
                headers: {
                    'Accept': 'application/json',
                    'Content-type': 'application/json',
                    'Authorization': `Bearer ${this.user.token}`
                },
                body: JSON.stringify({
                    workingtime: {
                        start: timeStart,
                        end: timeEnd,
                    }
                })
            })
            this.$emit('updateCharts')
        },
        updateStartTime() {
            if (this.time === null)
                return;
            const current = new Date(this.time);
            const date = current.getFullYear()+'-'+(current.getMonth()+1)+'-'+current.getDate();
            const time = current.getHours() + ":" + current.getMinutes() + ":" + current.getSeconds();
            const dateTime = date +' '+ time;

            this.clock.startTime = dateTime;
        },
        async fetchClocks() {
            const url = "http://localhost:4000/api/clocks/" + this.user.id
            let result = await (
                await fetch(url, {
                    method: "GET",
                    headers: {
                        Accept: "application/json",
                        "Content-Type": "application/json",
                        'Authorization': `Bearer ${this.user.token}`
                    },
                })
            ).json();
            let clocks = result.data // récupération des clocks
            clocks.sort((a, b) => new Date(b.time) - new Date(a.time) ) // trier par time le plus recent

            if (clocks.length == 0)
                return;
            let clock = clocks[0] // clock la plus recente

            if (clock.status == false) {
                this.end()
            }
            else {
                let utc = new Date(clock.time)
                this.time = utc.setMinutes(utc.getMinutes() - new Date().getTimezoneOffset())
                let timePast = new Date() - new Date(this.time); // date de maintenant - date de début
                this.clock.hr = parseInt(timePast / 1000 / 3600)
                this.clock.min = parseInt(timePast / 1000 / 60) - this.clock.hr * 60
                this.clock.sec = parseInt(timePast / 1000) - this.clock.hr * 3600 - this.clock.min * 60
                this.start()
            }
        },
        async startAndStopClock() {
            let now = new Date()

            if (this.clock.started == true) {
                this.end()
            } else {
                this.time = now.getTime()
                this.start()
            }
            const url = 'http://localhost:4000/api/clocks/' + this.user.id
            await fetch(url, {
                method: 'POST',
                headers: {
                    'Accept': 'application/json',
                    'Content-type': 'application/json',
                    'Authorization': `Bearer ${this.user.token}`
                },
                body: JSON.stringify({
                    clock: {
                        time: now,
                        status: this.clock.started,
                    }
                })
            })
        }
    }
};
</script>


<style>

.wrapper {
    user-select: none;
}

.wrapper .time {
    height: 70px;
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 6px;
}

.wrapper .time span {
    width: 100px;
    text-align: center;
    font-size: 50px;
    font-weight: 500;
}

.time span.colone {
    width: 10px;
}

.wrapper .button {
    text-align: center;
    margin-top: 10px;
}

.button button {
    padding: 6px 16px;
    outline: none;
    border: none;
    margin: 0 5px;
    font-size: 19px;
    font-weight: 500;
    border-radius: 4px;
    cursor: pointer;
}

.text{
  color: aliceblue;
}
</style>